﻿<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="html" encoding="utf-8" indent="yes"/>
  <xsl:include href="plan-element.inc.xsl"/>

  <xsl:template match="/">
    <html xmlns="http://www.w3.org/1999/xhtml">
      <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
				<link rel="stylesheet" type="text/css" media="screen, print" href="/plan.css"/>
        <title><xsl:value-of select="*/internal-name"/></title>
      </head>
      <body>
        <xsl:apply-templates/>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="action">
    <h1>Action: <xsl:value-of select="internal-name"/></h1>
		<xsl:apply-templates select="preconditions"/>
		<xsl:apply-templates select="invariants"/>
		<xsl:apply-templates select="postconditions"/>
    <xsl:apply-templates select="parameters"/>
		<xsl:apply-templates select="exec"/>
  </xsl:template>
  
  <xsl:template match="exec">
    <div id="execution" class="section">
    <h2>Execution</h2>
    <p>
      <xsl:value-of select="method"/><span>(</span><xsl:apply-templates select="exec-parameters"/><span>)</span>
    </p>
    </div>
  </xsl:template>
  
  <xsl:template match="exec-parameters">
    <xsl:for-each select="object">
      <span><xsl:value-of select="."/></span>
      <xsl:if test="position() != last()">
        <span>, </span>
      </xsl:if>
    </xsl:for-each>
  </xsl:template>
  
</xsl:stylesheet>
